
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深入理解Python中的__builtin__和__builtins__ / iVAN</title>

    <meta name="description" content="深入理解Python中的__builtin__和__builtins__ 0.说明         这里的说明主要是以Python 2.7为例,因为在Python 3+中,__builtin__模块被命名为builtins,下面主要是探讨Python 2.x中__builtin__模块和__builtins__模块的区别和联系. 1.名称空间(Namespace)         首先不得不说名称空间,因为名称空间是Python中非常重要的一个概念,所谓名称空间,其实指的是名称(标识符)到对象的映射.         在一个正常的Python程序的执行过程中,至少存在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深入理解Python中的__builtin__和__builtins__</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>0.说明</strong></p>
<p>        这里的说明主要是以Python 2.7为例，因为在Python 3+中，__builtin__模块被命名为builtins，下面主要是探讨Python 2.x中__builtin__模块和__builtins__模块的区别和联系。</p>
<hr>
<p><strong>1.名称空间（Namespace）</strong></p>
<p>        首先不得不说名称空间，因为名称空间是Python中非常重要的一个概念，所谓名称空间，其实指的是名称（标识符）到对象的映射。</p>
<p>        在一个正常的Python程序的执行过程中，至少存在两个名称空间：</p>
<ul>
<li>内建名称空间</li>
<li>全局名称空间</li>
</ul>
<p>        如果定义了函数，则还会有局部名称空间，全局名称空间一般由在程序的全局变量和它们对应的映射对象组成，而局部名称空间则在函数内部由函数局部变量和它们对应的映射对象组成，这里关键的是内建名称空间，它到底是怎么产生的？</p>
<hr>
<p><strong>2.内建函数</strong></p>
<p>        在启动Python解释器之后，即使没有创建任何的变量或者函数，还是会有许多函数可以使用，比如：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>abs</code><code>(</code><code>-</code><code>1</code><code>)</code></p>
<p><code>1</code></p>
<p><code>&gt;&gt;&gt; </code><code>max</code><code>(</code><code>1</code><code>, </code><code>3</code><code>)</code></p>
<p><code>3</code></p>
</td>
</tr>
</tbody>
</table>
<p>        我们把这些函数称为内建函数，是因为它们不需要我们程序员作任何定义，在启动Python解释器的时候，就已经导入到内存当中供我们使用：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>abs</code></p>
<p><code>&lt;built</code><code>-</code><code>in</code> <code>function </code><code>abs</code><code>&gt;</code></p>
<p><code>&gt;&gt;&gt; </code></p>
<p><code>&gt;&gt;&gt; </code><code>max</code></p>
<p><code>&lt;built</code><code>-</code><code>in</code> <code>function </code><code>max</code><code>&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<hr>
<p><strong>3.内建名称空间与__builtins__</strong></p>
<p>        那么内建函数也是函数，虽然我们没有人为导入这些，但是正如前面所说，在启动Python解释器的时候，会自动帮我们导入，那么内建函数存在于哪里呢？</p>
<p>        其实准确地来说，是Python解释器在启动的时候会首先加载内建名称空间，内建名称空间有许多名字到对象之间映射，而这些名字其实就是内建函数的名称，对象就是这些内建函数本身（注意区分函数名称和函数对象的区别）。这些名称空间由__builtins__模块中的名字构成：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>dir</code><code>()</code></p>
<p><code>[</code><code>'__builtins__'</code><code>, </code><code>'__doc__'</code><code>, </code><code>'__name__'</code><code>, </code><code>'__package__'</code><code>]</code></p>
</td>
</tr>
</tbody>
</table>
<p>        可以看到有一个__builtins__的模块名称，这个模块本身定义了一个名称空间，即内建名称空间，我们不妨dir一下：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>dir</code><code>(__builtins__)</code></p>
<p><code>[</code><code>'ArithmeticError'</code><code>, </code><code>'AssertionError'</code><code>, </code><code>'AttributeError'</code><code>, </code><code>'BaseException'</code><code>, </code><code>'BufferError'</code><code>, </code><code>'BytesWarning'</code><code>, </code><code>'DeprecationWarning'</code><code>, </code><code>'EOFError'</code><code>, </code><code>'Ellipsis'</code><code>, </code><code>'EnvironmentError'</code><code>, </code><code>'Exception'</code><code>, </code><code>'False'</code><code>, </code><code>'FloatingPointError'</code><code>, </code><code>'FutureWarning'</code><code>, </code><code>'GeneratorExit'</code><code>, </code><code>'IOError'</code><code>, </code><code>'ImportError'</code><code>, </code><code>'ImportWarning'</code><code>, </code><code>'IndentationError'</code><code>, </code><code>'IndexError'</code><code>, </code><code>'KeyError'</code><code>, </code><code>'KeyboardInterrupt'</code><code>, </code><code>'LookupError'</code><code>, </code><code>'MemoryError'</code><code>, </code><code>'NameError'</code><code>, </code><code>'None'</code><code>, </code><code>'NotImplemented'</code><code>, </code><code>'NotImplementedError'</code><code>, </code><code>'OSError'</code><code>, </code><code>'OverflowError'</code><code>, </code><code>'PendingDeprecationWarning'</code><code>, </code><code>'ReferenceError'</code><code>, </code><code>'RuntimeError'</code><code>, </code><code>'RuntimeWarning'</code><code>, </code><code>'StandardError'</code><code>, </code><code>'StopIteration'</code><code>, </code><code>'SyntaxError'</code><code>, </code><code>'SyntaxWarning'</code><code>, </code><code>'SystemError'</code><code>, </code><code>'SystemExit'</code><code>, </code><code>'TabError'</code><code>, </code><code>'True'</code><code>, </code><code>'TypeError'</code><code>, </code><code>'UnboundLocalError'</code><code>, </code><code>'UnicodeDecodeError'</code><code>, </code><code>'UnicodeEncodeError'</code><code>, </code><code>'UnicodeError'</code><code>, </code><code>'UnicodeTranslateError'</code><code>, </code><code>'UnicodeWarning'</code><code>, </code><code>'UserWarning'</code><code>, </code><code>'ValueError'</code><code>, </code><code>'Warning'</code><code>, </code><code>'ZeroDivisionError'</code><code>, </code><code>'_'</code><code>, </code><code>'__debug__'</code><code>, </code><code>'__doc__'</code><code>, </code><code>'__import__'</code><code>, </code><code>'__name__'</code><code>, </code><code>'__package__'</code><code>, </code><code>'abs'</code><code>, </code><code>'all'</code><code>, </code><code>'any'</code><code>, </code><code>'apply'</code><code>, </code><code>'basestring'</code><code>, </code><code>'bin'</code><code>, </code><code>'bool'</code><code>, </code><code>'buffer'</code><code>, </code><code>'bytearray'</code><code>, </code><code>'bytes'</code><code>, </code><code>'callable'</code><code>, </code><code>'chr'</code><code>, </code><code>'classmethod'</code><code>, </code><code>'cmp'</code><code>, </code><code>'coerce'</code><code>, </code><code>'compile'</code><code>, </code><code>'complex'</code><code>, </code><code>'copyright'</code><code>, </code><code>'credits'</code><code>, </code><code>'delattr'</code><code>, </code><code>'dict'</code><code>, </code><code>'dir'</code><code>, </code><code>'divmod'</code><code>, </code><code>'enumerate'</code><code>, </code><code>'eval'</code><code>, </code><code>'execfile'</code><code>, </code><code>'exit'</code><code>, </code><code>'file'</code><code>, </code><code>'filter'</code><code>, </code><code>'float'</code><code>, </code><code>'format'</code><code>, </code><code>'frozenset'</code><code>, </code><code>'getattr'</code><code>, </code><code>'globals'</code><code>, </code><code>'hasattr'</code><code>, </code><code>'hash'</code><code>, </code><code>'help'</code><code>, </code><code>'hex'</code><code>, </code><code>'id'</code><code>, </code><code>'input'</code><code>, </code><code>'int'</code><code>, </code><code>'intern'</code><code>, </code><code>'isinstance'</code><code>, </code><code>'issubclass'</code><code>, </code><code>'iter'</code><code>, </code><code>'len'</code><code>, </code><code>'license'</code><code>, </code><code>'list'</code><code>, </code><code>'locals'</code><code>, </code><code>'long'</code><code>, </code><code>'map'</code><code>, </code><code>'max'</code><code>, </code><code>'memoryview'</code><code>, </code><code>'min'</code><code>, </code><code>'next'</code><code>, </code><code>'object'</code><code>, </code><code>'oct'</code><code>, </code><code>'open'</code><code>, </code><code>'ord'</code><code>, </code><code>'pow'</code><code>, </code><code>'print'</code><code>, </code><code>'property'</code><code>, </code><code>'quit'</code><code>, </code><code>'range'</code><code>, </code><code>'raw_input'</code><code>, </code><code>'reduce'</code><code>, </code><code>'reload'</code><code>, </code><code>'repr'</code><code>, </code><code>'reversed'</code><code>, </code><code>'round'</code><code>, </code><code>'set'</code><code>, </code><code>'setattr'</code><code>, </code><code>'slice'</code><code>, </code><code>'sorted'</code><code>, </code><code>'staticmethod'</code><code>, </code><code>'str'</code><code>, </code><code>'sum'</code><code>, </code><code>'super'</code><code>, </code><code>'tuple'</code><code>, </code><code>'type'</code><code>, </code><code>'unichr'</code><code>, </code><code>'unicode'</code><code>, </code><code>'vars'</code><code>, </code><code>'xrange'</code><code>, </code><code>'zip'</code><code>]</code></p>
</td>
</tr>
</tbody>
</table>
<p>        会看到我们熟悉的内建函数的名称，如list、dict等，当然还有一些异常和其它属性。</p>
<hr>
<p><strong>4.__builtins__与__builtin__的简单区别</strong></p>
<p>        既然内建名称空间由__builtins__模块中的名称空间定义，那么是不是也意味着内建名称空间中所对应的这些函数也是在__builtins__模块中实现的呢？</p>
<p>        显然不是的，我们可以在解释器中直接输入__builtins__：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>&gt;&gt;&gt; __builtins__</code></p>
<p><code>&lt;module </code><code>'__builtin__'</code> <code>(built</code><code>-</code><code>in</code><code>)&gt;</code></p>
</td>
</tr>
</tbody>
</table>
<p>        从结果中可以看到，__builtins__其实还是引用了__builtin__模块而已，这说明真正的模块是__builtin__，也就是说，前面提到的内建函数其实是在内建模块__builtin__中定义的，即__builtins__模块包含内建名称空间中内建名字的集合（因为它引用或者说指向了__builtin__模块），而真正的内建函数、异常和属性来自__builtin__模块。也就是说，在Python中，其实真正是只有__builtin__这个模块，并不存在__builtins__这个模块：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>import</code> <code>__builtin__</code></p>
<p><code>&gt;&gt;&gt; </code><code>import</code> <code>__builtins__</code></p>
<p><code>Traceback (most recent call last):</code></p>
<p><code>  </code><code>File</code> <code>"&lt;stdin&gt;"</code><code>, line </code><code>1</code><code>, </code><code>in</code> <code>&lt;module&gt;</code></p>
<p><code>ImportError: No module named __builtins__</code></p>
</td>
</tr>
</tbody>
</table>
<p>        可以看到，导入__builtin__模块并没有问题，但导入__builtins__模块时就会提示不存在，这充分说明了前面的结论，现在再次总结如下：</p>
<ul>
<li>在Python中并没有__builtins__这个模块，只有__builtin__模块，__builtins__模块只是在启动Python解释器时，解释器为我们自动创建的一个到__builtin__模块的引用</li>
</ul>
<p>        当然，至于这种引用到底是怎么样，可以看下面的深入区别。</p>
<hr>
<p><strong>5.__builtins__与__builtin__的深入区别</strong></p>
<p>        上面只是大概说了下__builtins__与__builtin__两个模块的简单区分而已，其实深究下去，要分成下面所提及的两种情况。</p>
<p><strong>（1）在主模块__main__中</strong></p>
<p>        其实我们在使用Python交互器的时候就是在主模块中进行操作，可以做如下验证：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>print</code> <code>__name__</code></p>
<p><code>__main__</code></p>
</td>
</tr>
</tbody>
</table>
<p>        在这种情况，__builtins__与__builtin__是完全一样的，它们指向的都是__builtin__这个内建模块：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>import</code> <code>__builtin__</code></p>
<p><code>&gt;&gt;&gt; __builtin__</code></p>
<p><code>&lt;module </code><code>'__builtin__'</code> <code>(built</code><code>-</code><code>in</code><code>)&gt;</code></p>
<p><code>&gt;&gt;&gt; __builtins__</code></p>
<p><code>&lt;module </code><code>'__builtin__'</code> <code>(built</code><code>-</code><code>in</code><code>)&gt;</code></p>
<p><code>&gt;&gt;&gt; __builtin__.__name__</code></p>
<p><code>'__builtin__'</code></p>
<p><code>&gt;&gt;&gt; __builtins__.__name__</code></p>
<p><code>'__builtin__'</code></p>
<p><code>&gt;&gt;&gt; __builtins__ </code><code>=</code><code>=</code> <code>__builtin__</code></p>
<p><code>True</code></p>
<p><code>&gt;&gt;&gt; __builtins__ </code><code>is</code> <code>__builtin__</code></p>
<p><code>True</code></p>
<p><code>&gt;&gt;&gt; </code><code>id</code><code>(__builtins__)</code></p>
<p><code>140295127423752</code></p>
<p><code>&gt;&gt;&gt; </code><code>id</code><code>(__builtin__)</code></p>
<p><code>140295127423752</code></p>
</td>
</tr>
</tbody>
</table>
<p>        可以看到，这时候__builtins__和__builtin__是完全一样的，它们都指向了同一个模块对象，其实这也是Python中引用传递的概念。</p>
<p>        其实这种情况跟我们创建一个变量并对它做一次引用传递时的情况是一样的，可以做如下测试：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>def</code> <code>func():</code></p>
<p><code>...     </code><code>print</code> <code>'test'</code></p>
<p><code>... </code></p>
<p><code>&gt;&gt;&gt; func</code></p>
<p><code>&lt;function func at </code><code>0x7f99012bdc08</code><code>&gt;</code></p>
<p><code>&gt;&gt;&gt; funcs</code></p>
<p><code>&lt;function func at </code><code>0x7f99012bdc08</code><code>&gt;</code></p>
<p><code>&gt;&gt;&gt; func.__name__</code></p>
<p><code>'func'</code></p>
<p><code>&gt;&gt;&gt; funcs.__name__</code></p>
<p><code>'func'</code></p>
<p><code>&gt;&gt;&gt; funcs </code><code>=</code><code>=</code> <code>func</code></p>
<p><code>True</code></p>
<p><code>&gt;&gt;&gt; funcs </code><code>is</code> <code>func</code></p>
<p><code>True</code></p>
<p><code>&gt;&gt;&gt; </code><code>id</code><code>(funcs)</code></p>
<p><code>140295126375432</code></p>
<p><code>&gt;&gt;&gt; </code><code>id</code><code>(func)</code></p>
<p><code>140295126375432</code></p>
</td>
</tr>
</tbody>
</table>
<p>        显然，这完全验证了我们上面的结论。</p>
<p><strong>（2）不是在主模块中</strong></p>
<p>        如果不是在主模块中使用__builtins__，这时候，__builtins__只是对__builtin__.__dict__的一个简单引用而已，可以通过下面的测试来验证说明。</p>
<p>        先创建一个test.py模块，后面我们需要在Python交互器中导入它，那么这时候对于test模块来说，它就不是主模块了。如下：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21
</td>
<td>
<p><code>#!/usr/bin/env python</code></p>
<p> </p>
<p><code>import</code> <code>__builtin__</code></p>
<p> </p>
<p> </p>
<p><code>print</code> <code>'Module name:'</code><code>, __name__</code></p>
<p> </p>
<p> </p>
<p><code>print</code> <code>'*==test __builtin__ and __builtins__==*'</code></p>
<p><code>print</code> <code>'__builtin__ == __builtins__'</code><code>, __builtin__ </code><code>=</code><code>=</code> <code>__builtins__</code></p>
<p><code>print</code> <code>'__builtin__ is __builtins__'</code><code>, __builtin__ </code><code>is</code> <code>__builtins__</code></p>
<p><code>print</code> <code>'id(__builtin__)'</code><code>, </code><code>id</code><code>(__builtin__)</code></p>
<p><code>print</code> <code>'id(__builtins__)'</code><code>, </code><code>id</code><code>(__builtins__)</code></p>
<p> </p>
<p><code>print</code> <code>'='</code><code>*</code><code>50</code></p>
<p> </p>
<p><code>print</code> <code>'*==test __builtin__.__dict__ and __builtins__==*'</code></p>
<p><code>print</code> <code>'__builtin__.__dict__ == __builtins__'</code><code>, __builtin__.__dict__ </code><code>=</code><code>=</code> <code>__builtins__</code></p>
<p><code>print</code> <code>'__builtin__ is __builtins__'</code><code>, __builtin__.__dict__ </code><code>is</code> <code>__builtins__</code></p>
<p><code>print</code> <code>'id(__builtin__)'</code><code>, </code><code>id</code><code>(__builtin__.__dict__)</code></p>
<p><code>print</code> <code>'id(__builtins__)'</code><code>, </code><code>id</code><code>(__builtins__)</code></p>
</td>
</tr>
</tbody>
</table>
<p>        在Python交互器中导入上面这个test模块，如下：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13
</td>
<td>
<p><code>&gt;&gt;&gt; </code><code>import</code> <code>test</code></p>
<p><code>Module name: test</code></p>
<p><code>*</code><code>=</code><code>=</code><code>test __builtin__ </code><code>and</code> <code>__builtins__</code><code>=</code><code>=</code><code>*</code></p>
<p><code>__builtin__ </code><code>=</code><code>=</code> <code>__builtins__ </code><code>False</code></p>
<p><code>__builtin__ </code><code>is</code> <code>__builtins__ </code><code>False</code></p>
<p><code>id</code><code>(__builtin__) </code><code>140592847690504</code></p>
<p><code>id</code><code>(__builtins__) </code><code>140592847925608</code></p>
<p><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code><code>=</code></p>
<p><code>*</code><code>=</code><code>=</code><code>test __builtin__.__dict__ </code><code>and</code> <code>__builtins__</code><code>=</code><code>=</code><code>*</code></p>
<p><code>__builtin__.__dict__ </code><code>=</code><code>=</code> <code>__builtins__ </code><code>True</code></p>
<p><code>__builtin__ </code><code>is</code> <code>__builtins__ </code><code>True</code></p>
<p><code>id</code><code>(__builtin__) </code><code>140592847925608</code></p>
<p><code>id</code><code>(__builtins__) </code><code>140592847925608</code></p>
</td>
</tr>
</tbody>
</table>
<p>        可以看到输出的结果跟我们想的是完全一样的，即这时候__builtins__其实是对__builtin__.__dict__模块的引用。</p>
<hr>
<p><strong>6.总结</strong></p>
<p>        不管怎么说，在启动Python解释器或运行一个Python程序时，内建名称空间都是从__builtins__模块中加载的，只是__builtins__本身是对Python内建模块__builtin__的引用，而这种引用又分下面两种情况：</p>
<ul>
<li>如果是在主模块__main__中，__builtins__直接引用__builtin__模块，此时模块名__builtins__与模块名__builtin__指向的都是同一个模块，即&lt;builtin&gt;内建模块（这里要注意变量名和对象本身的区别）</li>
<li>如果不是在主模块中，那么__builtins__只是引用了__builtin__.__dict__</li>
</ul>
<p>        如果需要转载本文，请注明来自<a href="http://xpleaf.blog.51cto.com/" rel="external nofollow noreferrer">香飘叶子的51cto博客</a>。</p>
<p>        在写本文的时候，参考了下面的文章，只是这些文章并没有给出像上面我这样的测试，链接如下：</p>
<p><a href="https://docs.python.org/2/library/__builtin__.html?highlight=_builtin__#module-__builtin__" rel="external nofollow noreferrer">https://docs.python.org/2/library/__builtin__.html?highlight=_builtin__#module-__builtin__</a></p>
<p><a href="http://www.52ij.com/jishu/665.html" rel="external nofollow noreferrer">http://www.52ij.com/jishu/665.html</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-31 21:18:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/builtins/" title="builtins">builtins</a>, <a href="https://www.iamivan.net/tag/builtin/" title="builtin">builtin</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深入理解Python中的__builtin__和__builtins__的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Zy2Wz.html" rel="bookmark">深入理解Python中的ThreadLocal变量（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇我们看到了 ThreadLocal 变量的简单使用,中篇对python中 ThreadLocal 的实现进行了分析,但故事还没有结束.本篇我们一起来看下Werkzeug中ThreadLocal的设计. Werkzeug 作为一个 WSGI 工具库,由于一些方面的考虑,并没有直接使用python内置的ThreadLocal类,而是自己实现了一系列Local类.包括简单的Local,以及在此基础上实现的LocalStack,LocalManager 和 LocalProxy.接下来我们一起来看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQ7v4p.html" rel="bookmark">深入理解Python中的ThreadLocal变量（中）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在 深入理解Python中的ThreadLocal变量(上)中我们看到 ThreadLocal 的引入,使得可以很方便地在多线程环境中使用局部变量.如此美妙的功能到底是怎样实现的?如果你对它的实现原理没有好奇心或一探究竟的冲动,那么接下来的内容估计会让你后悔自己的浅尝辄止了. 简单来说,Python 中 ThreadLocal 就是通过下图中的方法,将全局变量伪装成线程局部变量,相信读完本篇文章你会理解图中内容的.(对这张图不眼熟的话,可以回顾下上篇)). 在哪里找到源码? 好了,终于要来分析			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQeL5p.html" rel="bookmark">理解Python中的装饰器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章先由stackoverflow上面的一个问题引起吧,如果使用如下的代码: @makebold @makeitalic def say(): return &quot;Hello&quot; 打印出如下的输出: &lt;b&gt;&lt;i&gt;Hello&lt;i&gt;&lt;/b&gt; 你会怎么做?最后给出的答案是: def makebold(fn): def wrapped(): return &quot;&lt;b&gt;&quot; + fn() + &quot;&lt;/b&gt;&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvY608b.html" rel="bookmark">进一步理解Python中的函数编程&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们最好从最难的问题开始:&quot;到底什么是函数编程 (FP)?&quot;一个答案可能会说 FP 就是您在使用例如 Lisp.Scheme.Haskell.ML.OCAML.Clean.Mercury.Erlang(或其它一些)语言进行编程时所做的.这是一个稳妥的答案,但不能很确切地阐明问题.不幸的是,即使是函数程序员他们自己也很难对 FP 究竟是什么有个一致的认识.&quot;盲人摸象&quot;的故事用来形容这一情况似乎很合适.还可以放心地将 FP 与&quot;命令编程&quot;(使用例如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrNGkp.html" rel="bookmark">深入理解Python中的元类&lpar;metaclass&rpar;&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				译注:这是一篇在Stack overflow上很热的帖子.提问者自称已经掌握了有关Python OOP编程中的各种概念,但始终觉得元类(metaclass)难以理解.他知道这肯定和自省有关,但仍然觉得不太明白,希望大家可以给出一些实际的例子和代码片段以帮助理解,以及在什么情况下需要进行元编程.于是e-satis同学给出了神一般的回复,该回复获得了985点的赞同点数,更有人评论说这段回复应该加入到Python的官方文档中去.而e-satis同学本人在Stack Overflow中的声望积分也高达6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWwLVqM.html" rel="bookmark">深入Python解释器理解Python中的字节码&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我最近在参与Python字节码相关的工作,想与大家分享一些这方面的经验.更准确的说,我正在参与2.6到2.7版本的CPython解释器字节码的工作. Python是一门动态语言,在命令行工具下运行时,本质上执行了下面的步骤:     当第一次执行到一段代码时,这段代码会被编译(如,作为一个模块加载,或者直接执行).根据操作系统的不同,这一步生成后缀名是pyc或者pyo的二进制文件.     解释器读取二进制文件,并依次执行指令(opcodes). Python解释器是基于栈的.要理解数据流向,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmVAJjz.html" rel="bookmark">理解Python中的类与实例&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				面向对象最重要的概念就是类(Class)和实例(Instance),必须牢记类是抽象的模板,比如Student类,而实例是根据类创建出来的一个个具体的&quot;对象&quot;,每个对象都拥有相同的方法,但各自的数据可能不同. 仍以Student类为例,在Python中,定义类是通过class关键字: class Student(object): pass class后面紧接着是类名,即Student,类名通常是大写开头的单词,紧接着是(object),表示该类是从哪个类继承下来的,继承的概念我们后面再			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ9Px8b.html" rel="bookmark">理解Python中函数的参数&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 定义函数的时候,我们把参数的名字和位置确定下来,函数的接口定义就完成了.对于函数的调用者来说,只需要知道如何传递正确的参数,以及函数将返回什么样的值就够了,函数内部的复杂逻辑被封装起来,调用者无需了解. Python的函数定义非常简单,但灵活度却非常大.除了正常定义的必选参数外,还可以使用默认参数.可变参数和关键字参数,使得函数定义出来的接口,不但能处理复杂的参数,还可以简化调用者的代码.默认参数 我们仍以具体的例子来说明如何定义函数的默认参数.先写一个计算x2的函数: def power(x			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7XKDb.html" rel="bookmark">理解 Python 中s可变参数的 &ast;args 和 &ast;&ast;kwargs</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用默认参数的可变参数 Python是支持可变参数的,最简单的方法莫过于使用默认参数,例如: def test_defargs(one, two = 2): print 'Required argument: ', one print 'Optional argument: ', two test_defargs(1) # result: # Required argument: 1 # Optional argument: 2 test_defargs(1, 3) # result: # Re			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrv54M.html" rel="bookmark" class="title">php错误提示failed to open stream&colon; HTTP request failed&excl;的完美解决方法</a>
					<div>
						google或者baidu一下,好多这样的问题,解决的方法都是修改php.ini,把allow_url_fopen给启用,改成 allow_url_fopen = On 这样做可以解决某些人的问题,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG3Y2z.html" rel="bookmark" class="title">学习XML你应该知道的一些基础知识</a>
					<div>
						一直都对XML有种望尘莫及的感觉,直到看到这篇文章,才终于让我对它的学习有了更进一步的掌握,原来,它是这么的有亲和力. 一直都对XML有种望尘莫及的感觉,直到看到这篇文章,才终于让我对它的学习有了更进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ7Xwb.html" rel="bookmark" class="title">SQL SERVER中一些常见性能问题的总结</a>
					<div>
						server|问题|性能 1.对查询进行优化,应尽量避免全表扫描,首先应考虑在 where 及 order by 涉及的列上建立索引. 2.应尽量避免在 where 子句中对字段进行 null 值判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAoZ3z.html" rel="bookmark" class="title">ASP&period;NET页面中显示数据库记录集最快的方法是什么？</a>
					<div>
						asp.net|记录集|数据|数据库|显示|页面 小鸡射手在DataGrid的使用实践中提到过DataGrid的性能问题,现看到了微软DEV411 ASP.NET:Best Practices For ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPoBDM.html" rel="bookmark" class="title">在WEB程序中设置个性化，容错提示窗口</a>
					<div>
						web|程序|容错 首先设计一个容错提示的窗口图像为如下: 关键HTML文本如下: &quot;原因:&lt;%=content[Int32.Parse(Request.QueryString[&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElWjqz.html" rel="bookmark" class="title">Oracle性能视图：v&dollar;session&lowbar;wait&lowbar;session</a>
					<div>
						1.表结构 SQL&gt; desc v$session_event 名称                                      是否为空? 类型 ---------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLV1Zb.html" rel="bookmark" class="title">Android 多个APK数据共享</a>
					<div>
						Android给每个APK进程分配一个单独的用户空间,其manifest中的userid就是对应一个Linux用户(Android 系统是基于Linux)的.所以不同APK(用户)间互相访问数据默认是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKEg1p.html" rel="bookmark" class="title">KV300技术分析&lpar;有关硬盘锁&rpar;</a>
					<div>
						注:此程序有一定的风险性.老妖也没有试过.希望大家考虑清楚了再行事. 要不是亲自试一下,你一定不会相信,运行下面的程序,你的机器将不能从软盘启动,更不能从硬盘启动.而这个程序仅仅修改了你的硬盘的扩展D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjO3np.html" rel="bookmark" class="title">php文件压缩之PHPZip类用法实例</a>
					<div>
						  本文实例讲述了php文件压缩之PHPZip类用法.分享给大家供大家参考.具体如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NGeJz.html" rel="bookmark" class="title">爱剪辑给视频加相框教程</a>
					<div>
						  一.为视频加相框 1.在&quot;叠加素材&quot;面板点击&quot;加相框&quot;栏目,在该栏目相框列表中,选择要应用的相框. 2.在相框列表底部,点击&quot;添加相框效果&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqL61Yb.html" rel="bookmark" class="title">EXCEL怎么制作双色柱形图图表&quest;</a>
					<div>
						  EXCEL怎么制作双色柱形图图表?日常工作中,大家经常会用到柱形图+折线图来表现数据与指标之间的趋势关系,今天我给大家介绍一种双色柱形图(即超过指标的柱形图用一种颜色表示,不达标的柱形图用另一种颜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNYDoM.html" rel="bookmark" class="title">ps制作下雨动态效果图</a>
					<div>
						  ps做下雨动态图主要使用到添加杂色.动感模糊以及动作和时间轴面板.笔者使用的photoshop CS6版本,因此下面的步骤都使用CS6操作和截图. ps下雨动态效果制作操作步骤如下: 1.找到一幅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL9anb.html" rel="bookmark" class="title">如何在win7旗舰版电脑中卸载打印机程序</a>
					<div>
						  1.首先,咱们直接单击打开win7旗舰版电脑的开始菜单,然后从开始菜单进入到设备和打印机选项中,这样就可以进入到咱们打印机程序的窗口了. 2.接下来,咱们在打开的窗口中找到自己需要卸载掉的打印机程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6KdXb.html" rel="bookmark" class="title">mavericks10&period;9自带英文输入法删除方法步骤详解</a>
					<div>
						  1,先将系统输入法配置成你自己想要的第三方输入法如搜狗.QQ等,加上英语输入法的最简状态,并将第三方输入法位置调到最靠上. 2,找到以下文件:~/Library/Preferences/com.a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVw8d4b.html" rel="bookmark" class="title">笔记本连接WiFi网速很慢怎么办</a>
					<div>
						  1.打开浏览器,在地址栏输入路由器地址(路由器底部有显示)并打开,输入路由器密码登录;   2.进入路由器管理界面,点击左侧的&quot;无线设置&quot;;   3.进入无线设置界面,将&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlwq5b.html" rel="bookmark" class="title">Mysql中order by语句的优化详解</a>
					<div>
						在某些情况中,MySQL可以使用一个索引来满足ORDER BY子句,而不需要额外的排序.where条件和order by使用相同的索引,并且order by的顺序和索引顺序相同,并且order by的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrakOM.html" rel="bookmark" class="title">高中学历自学android，做出这样的软件，可以找工作吗</a>
					<div>
						问题描述 高中学历自学android,做出这样的软件,可以找工作吗 感觉做出来啥感觉没有,就是数据库,解析json,绑定控件什么的,没什么技术 解决方案 第一,学历并不是什么问题,重要的是有技术,做多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr4m5M.html" rel="bookmark" class="title">医疗器械广告审查办法</a>
					<div>
						第一条 为加强医疗器械广告管理,保证医疗器械广告的真实性和合法性,根据&lt;中华人民共和国广告法&gt;(以下简称&lt;广告法&gt;).&lt;中华人民共和国反不正当竞争法&gt;.&lt;医疗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6N6wLM.html" rel="bookmark" class="title">网页中打开msn窗口方法</a>
					<div>
						msnim:chat?contact=aspboy2004@hotmail.com  打开msn窗口方法 &lt;a href=&quot;msnim:chat?contact=aspboy2004@ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7oY7p.html" rel="bookmark" class="title">Quartz任务调度&lpar;4&rpar;JobListener分版本超详细解析</a>
					<div>
						在&lt;spring学习笔记(15)趣谈spring 事件:实现业务逻辑解耦,异步调用提升用户体验&gt;我们通过实例分析讲解了spring的事件机制,或许你会觉得其中的配置略显繁琐,而在Quart ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NKeOM.html" rel="bookmark" class="title">西部大开发十二五规划编制启动</a>
					<div>
						核心提示:国家&quot;十二五&quot;期间,发展区域经济已被提上重要日程,尤其是中西部区域经济的发展.餐饮旅游的西安旅游.西安饮食.西藏旅游:农林牧渔的大禹节水.中粮屯河.新中基.通威股份等:商 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NlNYM.html" rel="bookmark" class="title">谁帮我做个程序</a>
					<div>
						问题描述 做一个用户登录程序,当用户登录时,输入身份证号和姓名(不需要注册),若系统中有该用户,则直接登录,并记录下登录时间和IP地址:若系统中无该用户,则以身份证号和姓名为关键字创建一条新记录,记录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rR6gz.html" rel="bookmark" class="title">java swing 打印-java swing 票据打印，每次打印的时候获取不到textfied里面的数据，请问怎么解决的？</a>
					<div>
						问题描述 java swing 票据打印,每次打印的时候获取不到textfied里面的数据,请问怎么解决的? java swing 票据打印,每次打印的时候获取不到textfied里面的数据,请问怎么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rZAAz.html" rel="bookmark" class="title">求高手，关于隐藏的问题</a>
					<div>
						问题描述 完全不懂JS,在破解电信无线猫的时候删TR069遇到了问题,在页面中隐藏了两段内容.一段用display:none改后可以显示,另一个是保存/应用按钮不知道是用什么方法隐藏的啊,请各位大侠帮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5Bd5M.html" rel="bookmark" class="title">ajax-我这段代码本页面可显示出传递的信息，但是在被传递页面中却无法接收到信息呢？谢谢！</a>
					<div>
						问题描述 我这段代码本页面可显示出传递的信息,但是在被传递页面中却无法接收到信息呢?谢谢! &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Co ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAj5QM.html" rel="bookmark" class="title">搜索竞价排名导致虚假药品肆虐</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 搜索引擎公司&quot;生财有道& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nBX7z.html" rel="bookmark" class="title">谁会成为黑客敲诈的目标？</a>
					<div>
						    对于一个没节操的黑客来说,他关心的唯一指标就是:投入精力和回报金钱的比值.在现在网络安全漏洞百出,追查手段捉襟见肘的情况下,敲诈成为了非常合算的生意.虽然我们不愿承认,但对于敲诈者来说,现在算 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkdWNM.html" rel="bookmark" class="title">android 捕获系统异常并上传日志具体实现&lowbar;Android</a>
					<div>
						在做项目时,经常会把错误利用异常抛出去,这样在开发时就可以通过手机抛出的异常排查错误.但是当程序开发完毕,版本稳定,需要上线时,为了避免抛出异常影响用户感受,可以用UncaughtExceptionH ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NVqnz.html" rel="bookmark" class="title">python中urllib模块用法实例详解&lowbar;python</a>
					<div>
						本文实例讲述了python中urllib模块用法.分享给大家供大家参考.具体分析如下: 一.问题: 近期公司项目的需求是根据客户提供的api,我们定时去获取数据, 之前的方案是用php收集任务存入到r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0NQxp.html" rel="bookmark" class="title">nodejs加密Crypto的实例代码&lowbar;node&period;js</a>
					<div>
						加密技术通常分为两大类:&quot;对称式&quot;和&quot;非对称式&quot;. 对称式加密: 就是加密和解密使用同一个密钥,通常称之为&quot;Session Key &quot;这种加 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
